/***************************************/
/*  Use MADS http://mads.atari8.info/  */
/*  Mode: DLI (char mode)              */
/***************************************/

scr48	= %00111111	;screen 48b
scr40	= %00111110	;screen 40b
scr32	= %00111101	;screen 32b

cloc	= $0014		;(1)
byt2	= $0000		;(1) <$0100
byt3	= $0100		;(1) >$00FF

ftmp	= $80		;(2)
regA	= ftmp+2	;(1)
regX	= regA+1	;(1)
regY	= regX+1	;(1)

hposp0	= $D000
hposp1	= $D001
hposp2	= $D002
hposp3	= $D003
hposm0	= $D004
hposm1	= $D005
hposm2	= $D006
hposm3	= $D007
sizep0	= $D008
sizep1	= $D009
sizep2	= $D00A
sizep3	= $D00B
sizem	= $D00C

colpm0	= $D012
colpm1	= $D013
colpm2	= $D014
colpm3	= $D015
color0	= $D016
color1	= $D017
color2	= $D018
color3	= $D019
colbak	= $D01A
gtictl	= $D01B

chbase	= $D409


* ---	MAIN PROGRAM
	org $2000

ant	ANTIC_PROGRAM scr,ant

scr	SCREEN_DATA

	ALIGN $0400
fnt	FONTS

	ALIGN $0800
	.ds $0300
pmg	SPRITES

main
* ---	init PMG
	mva >pmg $d407		;missiles and players data address
	mva #3 $d01d		;enable players and missiles

	ift .def CHANGES	;if label CHANGES defined
	jsr save_color		;then save all colors and set value 0 for all colors
	eif

	lda:cmp:req 20		;wait 1 frame

	sei			;stop IRQ interrupts
	mva #0 $d40e		;stop NMI interrupts
	mva #$fe $d301		;switch off ROM to get 16k more ram

	mwa #NMI $fffa		;new NMI handler

	mva #$c0 $d40e		;switch on NMI+DLI again


	jsr fade_in		;fade in colors


;
; MUSIC init & play
; example by Raster/C.P.U., 2003-2004
;
;
STEREOMODE	equ 0				;0 => compile RMTplayer for mono 4 tracks

MODUL	equ $9400

PLAYER	equ $4000
VCOUNT	equ $d40b				;vertical screen lines counter address

;						;1 => compile RMTplayer for stereo 8 tracks
;						;2 => compile RMTplayer for 4 tracks stereo L1 R2 R3 L4
;						;3 => compile RMTplayer for 4 tracks stereo L1 L2 R3 R4
;
;
;
	ldx #<MODUL			;low byte of RMT module to X reg
	ldy #>MODUL			;hi byte of RMT module to Y reg
	lda #0				;starting song line 0-255 to A reg
	jsr RASTERMUSICTRACKER		;Init
;Init returns instrument speed (1..4 => from 1/screen to 4/screen)
	tay
	lda tabpp-1,y
	sta acpapx2+1			;sync counter spacing
	lda #16+0
	sta acpapx1+1			;sync counter init
;

loop
acpapx1	lda #$ff			;parameter overwrite (sync line counter value)
	clc
acpapx2	adc #$ff			;parameter overwrite (sync line counter spacing)
	cmp #156
	bcc lop4
	sbc #156
lop4
	sta acpapx1+1
waipap
	cmp VCOUNT			;vertical line counter synchro
	bne waipap
;
	jsr RASTERMUSICTRACKER+3	;1 play
;
	lda $d20f			;wait to press any key; here you can put any own routine
	and #4
	bne loop			;no => loop
;
stopmusic

	jsr RASTERMUSICTRACKER+9	;all sounds off
;
	rts
;
tabpp  dta 156,78,52,39			;line counter spacing table for instrument speed from 1 to 4
;
;

	
	icl "rmtplayr.a65"			;include RMT player routine
;
	.print 'player ',player,'..',*


* ---	DLI PROGRAM

 ?old_dli = *

dli1
	lda $d40b
	cmp #2
	bne dli1
	:3 sta $d40a
	DLINEW dli8

dli_start
dli8

c5	lda #$CA
	sta $d40a		;line=56
	sta color2
	DLINEW dli9

dli9

c6	lda #$D8
	sta $d40a		;line=64
	sta color0
	DLINEW dli10

dli10

c7	lda #$C6
c8	ldx #$86
	sta $d40a		;line=88
	sta color2
	stx color3
	DLINEW dli11

dli11

c9	lda #$46
c10	ldx #$EE
	sta $d40a		;line=96
	sta color0
	stx color1
	DLINEW dli12

dli12

c11	lda #$1A
	sta $d40a		;line=128
	sta color3
	DLINEW dli2


dli2
	lda >fnt+$400*$01
	sta $d40a		;line=184
	sta chbase
	DLINEW dli3

dli3
	lda >fnt+$400*$00
	sta $d40a		;line=192
	sta chbase
	DLINEW dli4

dli4
	lda >fnt+$400*$01
c12	ldx #$0E
	sta $d40a		;line=208
	sta chbase
	stx color3
	DLINEW dli5

dli5
	lda >fnt+$400*$00
	sta $d40a		;line=224
	sta chbase
	jmp NMI.quit

;---

CHANGES

;---

.PROC NMI
	sta regA
	stx regX
	sty regY

	bit $d40f
	bpl VBL

	jmp dli_start
dliv	equ *-2

VBL
	sta $d40f		;reset NMI flag

	inc cloc		;little timer

	mwa #ant $d402		;ANTIC address program

	mva #scr40 $d400	;set new screen's width

;--- first line of screen initialization

	lda >fnt
	sta chbase
c0	lda #$00
	sta colbak
c1	lda #$74
	sta color0
c2	lda #$0E
	sta color1
c3	lda #$8A
	sta color2
c4	lda #$26
	sta color3
	lda #$04
	sta gtictl

	mwa #dli_start dliv	;set the first address of DLI interrupt

;this area is for yours routines

quit
	lda regA
	ldx regX
	ldy regY
	rti

.ENDP

;---
	icl 'mariobros_title.fad'


	org MODUL
	ins 'mario_strip.rmt',6


	run main

;---

	opt l-

.macro	SPRITES
	.ds $100
	.ds $100
	.ds $100
	.ds $100
	.ds $100
.endm

.macro	DLINEW
	ift .hi(?old_dli)==.hi(:1)
	mva <:1 NMI.dliv
	els
	mwa #:1 NMI.dliv
	eif

	jmp NMI.quit

	?old_dli = *
.endm

.macro	ALIGN
	ift (*/:1)*:1<>*
	org (*/:1)*:1+:1
	eif
.endm

.macro	ANTIC_PROGRAM
	dta $70,$70,$44,a(:1),$04,$04,$04,$84,$84,$04,$04,$84,$F0,$70,$04
	dta $04,$84,$04,$04,$70,$70,$04,$04,$84,$84,$70,$F0,$04,$84,$70,$70
	dta $41,a(:2)
.endm

.macro	SCREEN_DATA
	ins 'mariobros_title.scr'
.endm

.macro	FONTS
	ins 'mariobros_title.fnt'
.endm
